#define com_maroontress_libcgi_request_Map_IMPORT
#define com_maroontress_libcgi_request_Pair_IMPORT
#define com_maroontress_libcgi_request_RequestKit_IMPORT
#define com_maroontress_libcgi_util_Tub_IMPORT
#define std_io_InputTube_IMPORT

#include <stdlib.h>
#include <unistd.h>
#include <com/maroontress/libcgi/request/Map.h>
#include <com/maroontress/libcgi/request/Pair.h>
#include <com/maroontress/libcgi/request/RequestKit.h>
#include <com/maroontress/libcgi/util/Tub.h>
#include <std/io/InputTube.h>

struct RequestKit {
    union InputTube in;
    struct Pair *pair;
    struct Tub *tub;
};

static void
RequestKit_free(struct RequestKit *w)
{
    if (w == NULL)
	return;
    if (w->in.impl != NULL)
	InputTube_close(w->in);
    Pair_free(w->pair);
    Tub_free(w->tub);
    free(w);
}

static struct RequestKit *
RequestKit_create(union InputTube (*createInputTube)(void))
{
    struct RequestKit *w;

    if ((w = (struct RequestKit *)malloc(sizeof(*w))) == NULL)
	return NULL;
    w->in.impl = NULL;
    w->pair = NULL;
    w->tub = NULL;
    
    if ((w->in = createInputTube()).impl == NULL
	|| (w->tub = Tub_create()) == NULL
	|| (w->pair = Pair_create()) == NULL) {
	RequestKit_free(w);
	return NULL;
    }
    return w;
}

static int
RequestKit_load(struct RequestKit *w, struct Map *map)
{
    int s;

    while ((s = Pair_read(w->pair, w->in, w->tub)) == 0) {
	if (Map_put(map, Pair_getKey(w->pair), Pair_getValue(w->pair)) < 0) {
	    return -1;
	}
    }
    return (s < 0) ? -1 : 0;
}

int
RequestKit_loadMap(struct Map *map, union InputTube (*createInputTube)(void))
{
    struct RequestKit *w;
    int s;

    if ((w = RequestKit_create(createInputTube)) == NULL)
	return -1;
    s = RequestKit_load(w, map);
    RequestKit_free(w);
    return s;
}
